Index: ode/demo/demo_amplus.cpp
===================================================================
--- ode/demo/demo_amplus.cpp	(revision 0)
+++ ode/demo/demo_amplus.cpp	(working copy)
@@ -0,0 +1,497 @@
+/*************************************************************************
+ * AMPlus demo, written as part of the                                   *
+ * Open Dynamics Engine, Copyright (C) 2001,2002 Russell L. Smith.       *
+ * All rights reserved.  Email: russ@q12.org   Web: www.q12.org          *
+ *                                                                       *
+ *   This demo was built from demo_chain1.c                              *
+ *   Content novel to this file Copyright 2012, Joseph Cooper            *
+ *                                                                       *
+ * This library is free software; you can redistribute it and/or         *
+ * modify it under the terms of EITHER:                                  *
+ *   (1) The GNU Lesser General Public License as published by the Free  *
+ *       Software Foundation; either version 2.1 of the License, or (at  *
+ *       your option) any later version. The text of the GNU Lesser      *
+ *       General Public License is included with this library in the     *
+ *       file LICENSE.TXT.                                               *
+ *   (2) The BSD-style license that is included with this library in     *
+ *       the file LICENSE-BSD.TXT.                                       *
+ *                                                                       *
+ * Novel material in this file can also, at your option, be distributed  *
+ * under the ZLib license,                                               *
+ * see http://www.gzip.org/zlib/zlib_license.html                        *
+ *                                                                       *
+ * This library is distributed in the hope that it will be useful,       *
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the files    *
+ * LICENSE.TXT and LICENSE-BSD.TXT for more details.                     *
+ *                                                                       *
+ *************************************************************************/
+/* exercise the C interface */
+
+#include <stdio.h>
+#include "ode/ode.h"
+#include "drawstuff/drawstuff.h"
+#include "texturepath.h"
+
+
+#ifdef _MSC_VER
+#pragma warning(disable:4244 4305)  // for VC++, no precision loss complaints
+#endif
+
+/* select correct drawing functions */
+
+#ifdef dDOUBLE
+#define dsDrawBox dsDrawBoxD
+#define dsDrawSphere dsDrawSphereD
+#define dsDrawCylinder dsDrawCylinderD
+#define dsDrawCapsule dsDrawCapsuleD
+#define dsDrawLine dsDrawLineD
+#endif
+
+
+
+
+#define DENSITY (1000.0f) 
+
+/* dynamics and collision objects */
+static dWorldID world;
+static dSpaceID space;
+static dJointGroupID contactgroup;
+
+/* A 'plane' */
+static dBodyID planeBody;
+static dJointID planeAnchor;
+static dJointID planeLimit;
+static dReal planeDim[3] = {4,4,.1};
+
+/* A bunch of balls */
+#define SPHERENUM 1
+static dBodyID sphereBody[SPHERENUM];
+static dJointID sphereJoint[SPHERENUM];
+static dReal sphereRad = 0.1;
+
+/* Flippers */
+#define FLIPNUM 4
+static dBodyID lFlipper[FLIPNUM];
+static dJointID lFlipHinge[FLIPNUM];
+static dBodyID rFlipper[FLIPNUM];
+static dJointID rFlipHinge[FLIPNUM];
+static dReal flipDim[3] = {1.5,.1,.2};
+
+/* Tethered spinners*/
+#define SPINNUM 4
+static dBodyID spinner[SPINNUM];
+static dJointID spinAMP[SPINNUM];
+static dJointID spinLMP[SPINNUM];
+static dReal spinDim[3] = {.4,.05,.2};
+
+#define PADNUM 4
+static dBodyID paddle[PADNUM];
+static dJointID padAMP[PADNUM];
+static dJointID padLMP[PADNUM];
+static dReal padDim[3] = {.4,.05,.2};
+
+
+
+/* Popper */
+//static dBodyID popper;
+//static dJointID popAMP;
+//static dJointID popLMP;
+//static dReal popDim[3] = {0.5,0.5,0.01};
+
+static int lCntDown = 0;
+static int rCntDown = 0;
+/* this is called by dSpaceCollide when two objects in space are
+ * potentially colliding.
+ */
+static void nearCallback (void *data, dGeomID o1, dGeomID o2)
+{
+  /* exit without doing anything if the two bodies are connected by a joint */
+  dBodyID b1,b2;
+  dContact contact;
+
+  b1 = dGeomGetBody(o1);
+  b2 = dGeomGetBody(o2);
+
+  if (b1 && b2 && dAreConnectedExcluding( b1,b2,dJointTypeLMPlus)) return;
+  //if (b1 && b2 && dAreConnected( b1,b2)) return;
+
+  contact.surface.mode = 0;
+  contact.surface.mu = 0.1;
+  contact.surface.mu2 = 0;
+  if (dCollide (o1,o2,1,&contact.geom,sizeof(dContactGeom))) {
+    dJointID c = dJointCreateContact (world,contactgroup,&contact);
+    dJointAttach (c,b1,b2);
+  }
+}
+
+
+/* start simulation - set viewpoint */
+
+static void start()
+{
+  static float xyz[3] = {2.1640f,-5.3079f,2.7600f};
+  static float hpr[3] = {110.0000f,0.0000f,0.0000f};
+
+  dAllocateODEDataForThread(dAllocateMaskAll);
+  dsSetViewpoint (xyz,hpr);
+
+  printf("'z'   - left paddles\n");
+  printf("'/'   - right paddles\n");
+  printf("'s'   - stop all\n");
+  printf("space - tilt\n");
+}
+
+void stopall();
+/* simulation loop */
+static void simLoop (int pause)
+{
+  int i;
+  static dReal tv = 0;
+  static int reset = 20;
+
+  if (!pause) {
+    /* Because we're lazy and create all the joints
+       in an unsatisfied state, we kill all of the
+       momentum after a fixed number of frames (once
+       most of the error is resolved). */
+    if (reset>0) {
+      --reset;
+      if (reset==0) stopall(); /* Kill all momentum. */
+    }
+    /* The stops work much better with smaller time steps */
+    for (i=0;i<16;++i) {
+      dSpaceCollide (space,0,&nearCallback);
+      /* Either stepper seems to work fine. */
+      //dWorldStep (world,0.001); 
+      dWorldQuickStep(world, 0.001);
+      /* remove all contact joints */
+      dJointGroupEmpty (contactgroup);
+    }
+    if (lCntDown>0) {
+      lCntDown-=1;
+      if (lCntDown==0) {
+        for (i=0;i<FLIPNUM;++i) {
+          dJointSetHingeParam(lFlipHinge[i],dParamVel, -5);
+        }
+      }
+    }
+    if (rCntDown>0) {
+      rCntDown-=1;
+      if (rCntDown==0) {
+        for (i=0;i<FLIPNUM;++i) {
+          dJointSetHingeParam(rFlipHinge[i],dParamVel,  5);
+        }
+      }
+    }
+
+  }
+
+  dsSetColor (1,1,0);
+  dsSetTexture (DS_WOOD);
+
+  /* Draw the balls */
+  for (i=0;i<SPHERENUM;++i) {
+    dsDrawSphere(dBodyGetPosition(sphereBody[i]),dBodyGetRotation(sphereBody[i]),sphereRad);
+  }
+
+  /* Draw the flippers */
+  dsSetColor(1,.5f,0);
+  for (i=0;i<FLIPNUM;++i) {
+    dsDrawBox(dBodyGetPosition(lFlipper[i]),dBodyGetRotation(lFlipper[i]),flipDim);
+    dsDrawBox(dBodyGetPosition(rFlipper[i]),dBodyGetRotation(rFlipper[i]),flipDim);
+  }
+
+  dsSetColor(1,0,1);
+  for (i=0;i<PADNUM;++i) {
+    dsDrawBox(dBodyGetPosition(paddle[i]),dBodyGetRotation(paddle[i]),padDim);
+  }
+
+  dsSetColor(0,.5f,0);
+  for (i=0;i<SPINNUM;++i) {
+    dsDrawBox(dBodyGetPosition(spinner[i]),dBodyGetRotation(spinner[i]),spinDim);
+  }
+
+  /*dsSetColor(0.2f,.2f,0.2f);
+  dsDrawBox(dBodyGetPosition(popper),dBodyGetRotation(popper),popDim);*/
+  
+
+  /* Draw the game plane. */
+  dsSetColor(0,0,1);
+  dsDrawBox(dBodyGetPosition(planeBody),dBodyGetRotation(planeBody),planeDim);
+}
+
+void stopBody(dBodyID b)
+{
+  dBodySetLinearVel(b,0,0,0);
+  dBodySetAngularVel(b,0,0,0);
+}
+
+void stopall()
+{
+  int i;
+  stopBody(planeBody);
+  for (i=0;i<FLIPNUM;++i) {
+    stopBody(lFlipper[i]);
+    stopBody(rFlipper[i]);
+  }
+  for (i=0;i<SPINNUM;++i) {
+    stopBody(spinner[i]);
+  }
+  for (i=0;i<PADNUM;++i) {
+    stopBody(paddle[i]);
+  }
+}
+
+void command(int c)
+{
+  int i;
+  switch (c) {
+    case 's':
+      stopall();
+
+      break;
+    case 'z':
+      for (i=0;i<FLIPNUM;++i) {
+        dJointAddHingeTorque(lFlipHinge[i],500);
+        dJointSetHingeParam(lFlipHinge[i],dParamVel,20);
+        lCntDown=30;
+      }
+      break;
+    case '/':
+      for (i=0;i<FLIPNUM;++i) {
+        dJointAddHingeTorque(rFlipHinge[i],-500);
+        dJointSetHingeParam(rFlipHinge[i],dParamVel, -20);
+        rCntDown=30;
+      }
+      break;
+    case ' ':
+      dJointAddAMPlusTorque(planeLimit,0,-500000);
+      //dJointAddAMPlusTorque(popAMP,1,1000);
+      break;
+  }
+}
+
+void rotateBody(dBodyID b,dVector3 ax,dReal ang)
+{
+  dQuaternion qAdd;
+  dQuaternion qReplace;
+  const dReal* qBody;
+  
+  dQFromAxisAndAngle(qAdd,ax[0],ax[1],ax[2],ang);
+  qBody = dBodyGetQuaternion(b);
+
+  /* Unlike vector operations, quaternion multiplication
+     has not been made safe against aliasing; so we need
+     an extra variable here. */
+  dQMultiply0(qReplace,qAdd,qBody);
+  dBodySetQuaternion(b,qReplace);
+}
+
+int main (int argc, char **argv)
+{
+  dMass m;
+  int i;
+  dVector3 yAxis={0,1,0,0};
+  dVector3 zAxis={0,0,1,0};
+
+  /* setup pointers to drawstuff callback functions */
+  dsFunctions fn;
+  fn.version = DS_VERSION;
+  fn.start = &start;
+  fn.step = &simLoop;
+  fn.command = &command;
+  fn.stop = 0;
+  fn.path_to_textures = DRAWSTUFF_TEXTURE_PATH;
+
+  /* create world */
+  dInitODE2(0);
+  world = dWorldCreate();
+  space = dHashSpaceCreate (0);
+  contactgroup = dJointGroupCreate (0);
+  dWorldSetGravity (world,0,0,-10);
+  dWorldSetQuickStepNumIterations(world, 50);
+  dCreatePlane (space,0,0,1,0); /* Ground plane*/
+  dWorldSetMaxAngularSpeed(world,25);
+
+
+  /* We create a big flat box.  */
+  dMassSetBox(&m,DENSITY/4,planeDim[0],planeDim[1],planeDim[2]);
+  planeBody = dBodyCreate(world);
+  dBodySetMass(planeBody,&m);
+  dGeomSetBody(dCreateBox(space,planeDim[0],planeDim[1],planeDim[2]),planeBody);
+  dBodySetPosition(planeBody,0,0,1);
+  planeAnchor = dJointCreateBall(world,0);
+  dJointAttach(planeAnchor,planeBody,0);
+  dJointSetBallAnchor(planeAnchor,0,0,1);
+  planeLimit = dJointCreateAMPlus(world,0);
+  dJointAttach(planeLimit,planeBody,0);
+  dJointSetAMPlusAxis1Rel(planeLimit,0,0,0,1);
+  dJointSetAMPlusAxis2Rel(planeLimit,0,0,0,1);
+  dJointSetAMPlusParam(planeLimit,dParamHiStop,M_PI/24);
+  //dJointSetAMPlusParam(planeLimit,dParamVel,0);
+  //dJointSetAMPlusParam(planeLimit,dParamFMax,10000);
+
+  /*dJointSetAMPlusAxis1Rel(planeLimit,1,1,0,0); 
+  dJointSetAMPlusAxis2Rel(planeLimit,1,1,0,0);
+  dJointSetAMPlusAxisRefRel(planeLimit,1,2,0,0,1);
+  dJointSetAMPlusParam(planeLimit,dParamFMax2,10);
+  dJointSetAMPlusParam(planeLimit,dParamVel2,0);
+  dJointSetAMPlusMode(planeLimit,1,dAMPlusProjected);
+  dJointSetAMPlusParam(planeLimit,dParamLoStop2,-M_PI/4);
+  dJointSetAMPlusParam(planeLimit,dParamHiStop2,M_PI/4);*/
+  
+  /* We create a bunch of paddles. */
+  dMassSetBox(&m,DENSITY/4,flipDim[0],flipDim[1],flipDim[2]);
+  for (i=0;i<FLIPNUM;++i) {
+    lFlipper[i] = dBodyCreate(world);
+    rFlipper[i] = dBodyCreate(world);
+    dBodySetMass(lFlipper[i],&m);
+    dBodySetMass(rFlipper[i],&m);
+    dGeomSetBody(dCreateBox(space,flipDim[0],flipDim[1],flipDim[2]),lFlipper[i]);
+    dGeomSetBody(dCreateBox(space,flipDim[0],flipDim[1],flipDim[2]),rFlipper[i]);
+    lFlipHinge[i] = dJointCreateHinge(world,0);
+    rFlipHinge[i] = dJointCreateHinge(world,0);
+    dJointAttach(lFlipHinge[i],lFlipper[i],planeBody);
+    dJointAttach(rFlipHinge[i],rFlipper[i],planeBody);
+
+    dBodySetPosition(lFlipper[i],
+      -flipDim[0]/2-sphereRad,
+      -planeDim[1]/2-3*flipDim[1]/4,
+      1+flipDim[2]/2+planeDim[2]/2);
+    dBodySetPosition(rFlipper[i],
+       flipDim[0]/2+sphereRad,
+      -planeDim[1]/2-3*flipDim[1]/4,
+      1+flipDim[2]/2+planeDim[2]/2);
+    dJointSetHingeAnchor(lFlipHinge[i],
+      -flipDim[0],
+      -planeDim[1]/2,
+      1+flipDim[2]/2);
+    dJointSetHingeAnchor(rFlipHinge[i],
+       flipDim[0],
+      -planeDim[1]/2,
+      1+flipDim[2]/2+planeDim[2]);
+    dJointSetHingeAxis(lFlipHinge[i],0,0,1);
+    dJointSetHingeAxis(rFlipHinge[i],0,0,1);
+    dJointSetHingeParam(lFlipHinge[i],dParamLoStop,0);
+    dJointSetHingeParam(rFlipHinge[i],dParamLoStop,-M_PI/4);
+    dJointSetHingeParam(lFlipHinge[i],dParamHiStop,M_PI/4);
+    dJointSetHingeParam(rFlipHinge[i],dParamHiStop,0);
+    dJointSetHingeParam(lFlipHinge[i],dParamFMax,200);
+    dJointSetHingeParam(rFlipHinge[i],dParamFMax,200);
+    dJointSetHingeParam(lFlipHinge[i],dParamVel,-5);
+    dJointSetHingeParam(rFlipHinge[i],dParamVel, 5);
+
+    rotateBody(planeBody,zAxis,M_PI/2);
+  }
+
+  /* Create the balls */
+  dMassSetSphere(&m,DENSITY,sphereRad);
+  for (i = 0; i<SPHERENUM; ++i) {
+    sphereBody[i] = dBodyCreate(world);
+    dBodySetMass(sphereBody[i],&m);
+    dGeomSetBody( dCreateSphere(space,sphereRad), sphereBody[i]);
+    sphereJoint[i] = dJointCreateLMPlus(world,0);
+    dJointAttach(sphereJoint[i],sphereBody[i],planeBody);
+    dJointSetLMPlusAxisRel(sphereJoint[i],0,2,1,0,0);
+    dJointSetLMPlusAxisRel(sphereJoint[i],1,2,0,1,0);
+    dJointSetLMPlusAxisRel(sphereJoint[i],2,2,0,0,1);
+    dJointSetLMPlusParam(sphereJoint[i],dParamLoStop1,-planeDim[0]/2);
+    dJointSetLMPlusParam(sphereJoint[i],dParamHiStop1, planeDim[0]/2);
+    dJointSetLMPlusParam(sphereJoint[i],dParamLoStop2,-planeDim[1]/2);
+    dJointSetLMPlusParam(sphereJoint[i],dParamHiStop2, planeDim[1]/2);
+    dJointSetLMPlusParam(sphereJoint[i],dParamLoStop3, 0);
+    dJointSetLMPlusParam(sphereJoint[i],dParamHiStop3, planeDim[2]/2+2);
+  }
+
+  dMassSetBox(&m,DENSITY/4,spinDim[0],spinDim[1],spinDim[2]);
+  for (i=0;i<SPINNUM;++i) {
+    spinner[i] = dBodyCreate(world);
+    dBodySetMass(spinner[i],&m);
+    dGeomSetBody(dCreateBox(space,spinDim[0],spinDim[1],spinDim[2]),spinner[i]);
+    //dBodySetPosition(spinner[i],0,i*spinDim[1],3+planeDim[2]/2+spinDim[0]/2);
+    
+    spinAMP[i] = dJointCreateAMPlus(world,0);
+    dJointAttach(spinAMP[i],spinner[i],planeBody);
+    rotateBody(spinner[i],yAxis,M_PI/2);
+    dJointSetAMPlusUniversal(spinAMP[i],1,0,0, 0,0,1);
+
+    spinLMP[i] = dJointCreateLMPlus(world,0);
+    dJointAttach(spinLMP[i],spinner[i],planeBody);
+    dJointSetLMPlusAnchor1Rel(spinLMP[i],0,0,0);
+    dJointSetLMPlusAnchor2Rel(spinLMP[i],0,0,0);
+    dJointSetLMPlusAxis(spinLMP[i],0,2,1,0,0);
+    dJointSetLMPlusAxis(spinLMP[i],1,2,0,1,0);
+    dJointSetLMPlusAxis(spinLMP[i],2,2,0,0,1);
+    dJointSetLMPlusParam(spinLMP[i],dParamLoStop1,-planeDim[0]/2);
+    dJointSetLMPlusParam(spinLMP[i],dParamHiStop1, planeDim[0]/2);
+    dJointSetLMPlusParam(spinLMP[i],dParamLoStop2,-planeDim[1]/2);
+    dJointSetLMPlusParam(spinLMP[i],dParamHiStop2, planeDim[1]/2);
+    dJointSetLMPlusParam(spinLMP[i],dParamLoStop3, planeDim[2]/2 + spinDim[0]/2);
+    dJointSetLMPlusParam(spinLMP[i],dParamHiStop3, planeDim[2]/2 + spinDim[0]/2);
+  }
+
+  dMassSetBox(&m,DENSITY/4,padDim[0],padDim[1],padDim[2]);
+  for (i=0;i<PADNUM;++i) {
+    paddle[i] = dBodyCreate(world);
+    dBodySetMass(paddle[i],&m);
+    dGeomSetBody(dCreateBox(space,padDim[0],padDim[1],padDim[2]),paddle[i]);
+    //dBodySetPosition(paddle[i],i*padDim[2],1,3+planeDim[2]/2+padDim[0]);
+    
+    padAMP[i] = dJointCreateAMPlus(world,0);
+    dJointAttach(padAMP[i],paddle[i],planeBody);
+    rotateBody(paddle[i],yAxis,M_PI/2);
+    dJointSetAMPlusHinge(padAMP[i],1,0,0);
+
+    padLMP[i] = dJointCreateLMPlus(world,0);
+    dJointAttach(padLMP[i],paddle[i],planeBody);
+    dJointSetLMPlusAnchor1Rel(padLMP[i],padDim[0]/2,0,0);
+    dJointSetLMPlusAnchor2Rel(padLMP[i],0,0,0);
+    dJointSetLMPlusAxis(padLMP[i],0,2,1,0,0);
+    dJointSetLMPlusAxis(padLMP[i],1,2,0,1,0);
+    dJointSetLMPlusAxis(padLMP[i],2,2,0,0,1);
+    dJointSetLMPlusParam(padLMP[i],dParamLoStop1,-planeDim[0]/2);
+    dJointSetLMPlusParam(padLMP[i],dParamHiStop1, planeDim[0]/2);
+    dJointSetLMPlusParam(padLMP[i],dParamLoStop2,-planeDim[1]/2);
+    dJointSetLMPlusParam(padLMP[i],dParamHiStop2, planeDim[1]/2);
+    dJointSetLMPlusParam(padLMP[i],dParamLoStop3, planeDim[2]/2 + padDim[0]);
+    dJointSetLMPlusParam(padLMP[i],dParamHiStop3, planeDim[2]/2 + padDim[0]);
+  }
+
+  /* We create a popper.  */
+  //dMassSetBox(&m,DENSITY/4,popDim[0],popDim[1],popDim[2]);
+  //popper = dBodyCreate(world);
+  //dBodySetMass(popper,&m);
+  //dGeomSetBody(dCreateBox(space,popDim[0],popDim[1],popDim[2]),popper);
+
+  //popAMP = dJointCreateAMPlus(world,0);
+  //dJointAttach(popAMP,popper,planeBody);
+  ////dJointSetAMPlusHinge(popAMP,1,0,0);
+  //dJointSetAMPlusUniversal(popAMP,1,0,0, 0,0,1);
+  //dJointSetAMPlusParam(popAMP,dParamLoStop2,-0.001);
+  //dJointSetAMPlusParam(popAMP,dParamHiStop2,M_PI/2);
+
+  //popLMP = dJointCreateLMPlus(world,0);
+  //dJointAttach(popLMP,popper,planeBody);
+  //dJointSetLMPlusAnchor1Rel(popLMP,0.01,popDim[1]/2,popDim[2]/2);
+  //dJointSetLMPlusAnchor2Rel(popLMP,0,0,planeDim[2]/2);
+  //dJointSetLMPlusAxis(popLMP,0,2,1,0,0);
+  //dJointSetLMPlusAxis(popLMP,1,2,0,1,0);
+  //dJointSetLMPlusAxis(popLMP,2,2,0,0,1);
+  //dJointSetLMPlusParam(popLMP,dParamLoStop1,-planeDim[0]/3);
+  //dJointSetLMPlusParam(popLMP,dParamHiStop1, planeDim[0]/3);
+  //dJointSetLMPlusParam(popLMP,dParamLoStop2,-planeDim[1]/3);
+  //dJointSetLMPlusParam(popLMP,dParamHiStop2, planeDim[1]/3);
+  //dJointSetLMPlusParam(popLMP,dParamLoStop3, 0.01);
+  //dJointSetLMPlusParam(popLMP,dParamHiStop3, 0.01);
+
+  
+  /* run simulation */
+  dsSimulationLoop (argc,argv,352,288,&fn);
+
+  dJointGroupDestroy (contactgroup);
+  dSpaceDestroy (space);
+  dWorldDestroy (world);
+  dCloseODE();
+  return 0;
+}
